/*****************************************************************************
*                                                                            *
*              # AUTOR : pavol odlevak ( pmk )                               *
*                                                                            *
*              # DATUM : 10.12. 2005 - finish                                *
*                                                                            *
*	       # POD   : borland c++ 3.1                                     *
*                                                                            *
*	       # PROGRAM : sokoban-like game                                 *
*                                                                            *
*                                                                            *
*                                                                            *
*                                                                            *
* -> levels from Ksokoban - micro set                                        *
* -> ver 0.3                                                                 *
*****************************************************************************/

#include <graphics.h>
#include <stdlib.h>
#include <stdio.h>
#include <conio.h>
#include <string.h>
#define ZAC_X 60 /* body - horny lavy - od kt. sa zacina vykreslenie */
#define ZAC_Y 30

int pole[8][11];    /* rozmery hracieho pola       */
int stoji_tanier=0; /* =1 ak hrac stoji na tanieri */

void stena (int x, int y);  /* nakreslenie steny             */
void nic (int x, int y);    /* zmazanie predtym nakresleneho */
void ryba (int x, int y);   /* nakreslenie ryby              */
void tanier (int x, int y); /* taniera                       */
void vyhra ();              /* gratulacia po prejdeni levelu */
void panel (char path[19]); /* iformacny panel pocas hrania  */
void menu ();               /* uvodne menu                   */
void help ();               /* to je asi jasne */

/*-------------------------------------------------------------------------*/

class Tux {

  private:

  int pozI,pozJ;

  public:



  void tux_poz(int i, int j) {
    pozI = i;
    pozJ = j;
  }



  /* nakreslenie tux-a */
  void tux_show(int x, int y) {
    /* telo tux-a */
    setcolor(8);
    setfillstyle(1, 8);
    fillellipse(x, y,18 ,25 );
    /* ruky */
    setcolor(8);
    setfillstyle(1, 8);
    fillellipse(x-18, y+5,3 ,10 );
    fillellipse(x+18, y+5,3 ,10 );
    /* nohy */
    fillellipse(x-10, y+23,10 ,3 );
    fillellipse(x+10, y+23,10 ,3 );
    /* biele brucho */
    setcolor(15);
    setfillstyle(1, 15);
    fillellipse(x, y+14,8 ,9 );
    /* bile oci */
    fillellipse(x-6, y-12,3 ,5 );
    fillellipse(x+5, y-12,4 ,7 );
    /* zobak */
    setcolor(12);
    setfillstyle(1, 12);
    fillellipse(x, y-2,4 ,2 );
    fillellipse(x, y,2 ,1 );
    /* cierne oci */
    setcolor(8); setfillstyle(1, 8);
    fillellipse(x-6, y-12,1 ,2 );
    fillellipse(x+5, y-12,1 ,2 );
  }



  /* pohyb tux-a po hracej ploche */
  void tux_move (int i, int j, int pole[8][11]) {
    if (pole[pozI+i][pozJ+j]!=1) /* ked> nie je stena */ {

      /* ked> je ryba an tanieri */
      if (pole[pozI+i][pozJ+j]==5) {

	/* ked>> je nad rybou na tanieri prazdne */
	if (pole[pozI+(2*i)][pozJ+(2*j)]==0) {
	  pole[pozI+(2*i)][pozJ+(2*j)]=4;
	  pole[pozI+i][pozJ+j]=6;
	  pole[pozI][pozJ]=0;
	  if (stoji_tanier) {pole[pozI][pozJ]=2;stoji_tanier=0;}
	  stoji_tanier=1;
	}

	/* ked>> je nad rybou na tanieri tanier */
	if (pole[pozI+(2*i)][pozJ+(2*j)]==2) {
	  pole[pozI+(2*i)][pozJ+(2*j)]=5;
	  pole[pozI+i][pozJ+j]=6;
	  pole[pozI][pozJ]=0;
	  if (stoji_tanier) {pole[pozI][pozJ]=2;stoji_tanier=0;}
	  stoji_tanier=1;
	}

      }

      /* ked je ryba */
      if (pole[pozI+i][pozJ+j]==4) {

	/* ked>> je nad rybou prazdne */
	if (pole[pozI+(2*i)][pozJ+(2*j)]==0) {
	  pole[pozI+(2*i)][pozJ+(2*j)]=4;
	  pole[pozI+i][pozJ+j]=3;
	  pole[pozI][pozJ]=0;
	  if (stoji_tanier) {pole[pozI][pozJ]=2;stoji_tanier=0;}
	}

	/* ked>> je nad rybou tanier */
	if (pole[pozI+(2*i)][pozJ+(2*j)]==2) {
	  pole[pozI+(2*i)][pozJ+(2*j)]=5;
	  pole[pozI+i][pozJ+j]=3;
	  pole[pozI][pozJ]=0;
	  if (stoji_tanier) {pole[pozI][pozJ]=2;stoji_tanier=0;}
	}

      }

      /* ked> je prazdne */
      if (pole[pozI+i][pozJ+j]==0) {
	pole[pozI+i][pozJ+j]=3;
	pole[pozI][pozJ]=0;
	if (stoji_tanier) {pole[pozI][pozJ]=2;stoji_tanier=0;}
      }


      /* ked> je tanier*/
      if (pole[pozI+i][pozJ+j]==2) {
	pole[pozI+i][pozJ+j]=6;
	pole[pozI][pozJ]=0;
	if (stoji_tanier) {pole[pozI][pozJ]=2;stoji_tanier=0;}
	stoji_tanier=1;
      }

    }

  }

};

/*-----------------------------MAIN----------------------------------------*/

void main ( void )

{
  FILE *vst;
  int i, j, surx=ZAC_X, sury=ZAC_Y, klaves;
  int vyskyt_ryba;
  char cesta [19]="level\\level_01.PMK";  /* default level */
  int gdriver = DETECT, gmode, errorcode; /* pre grafiku */
  Tux tux;

  /*-------INICIALIZACIA-GRAFIKY-------------------------------------------*/

  initgraph(&gdriver, &gmode, "BGI");
  errorcode = graphresult();
  if (errorcode != grOk) {  /* ked je chyba */
    printf("Chyba pri inicializovani grafiky: %s\n", grapherrormsg(errorcode));
    printf("Pokracujte stlacenim lubovolneho klavesu:");
    getch();
    exit(1);          /* terminate with an error code */
  }

  /*-------UVODNE-MENU-&-VYBRATIE-LEVELU-----------------------------------*/

  do {
    menu();
    klaves = getch();
    if (!klaves)
      klaves = getch();

    switch (klaves) {
      case 59 : strcpy(cesta,"level\\level_01.PMK"); break; /* [F1] */
      case 60 : strcpy(cesta,"level\\level_02.PMK"); break;
      case 61 : strcpy(cesta,"level\\level_03.PMK"); break;
      case 62 : strcpy(cesta,"level\\level_04.PMK"); break;
      case 63 : strcpy(cesta,"level\\level_05.PMK"); break;
      case 64 : strcpy(cesta,"level\\level_06.PMK"); break; /* .... */
      case 65 : strcpy(cesta,"level\\level_07.PMK"); break;
      case 66 : strcpy(cesta,"level\\level_08.PMK"); break;
      case 67 : strcpy(cesta,"level\\level_09.PMK"); break;
      case 68 : strcpy(cesta,"level\\level_10.PMK"); break;
      case 133 : strcpy(cesta,"level\\level_11.PMK"); break;
      case 134 : strcpy(cesta,"level\\level_12.PMK"); break; /* [F12] */
      case 104 : help(); break;       /* [h] */
      case 27 : closegraph();exit(1); /* [Esc] */
    }

    /*-------PREVEDENIE-CISEL-ZO-SUBORU-DO-POLA----------------------------*/

    vst = fopen(cesta,"r");
    for (i=0;i<8;i++)
      for (j=0;j<11;j++) fscanf(vst,"%d",&pole[i][j]);
    fclose (vst);

    /*----------VYKRESLENIE-HRACEJ-PLOCHY-Z-POLA---------------------------*/

    cleardevice();
    panel(cesta);
    do {
      surx=ZAC_X;sury=ZAC_Y;
      for (i=0;i<8;i++) {
	for (j=0;j<11;j++) {
	  switch (pole[i][j]) {
	    case 0 : nic(surx,sury); break;

	    case 1 : stena(surx,sury); break;

	    case 2 : tanier(surx,sury); break;

	    case 3 : tux.tux_show(surx,sury);

		     tux.tux_poz(i,j); break;

	    case 4 : ryba(surx,sury); break;

	    case 5 : tanier(surx,sury);ryba(surx,sury); break;


	    case 6 : tanier(surx,sury);tux.tux_show(surx,sury);
		     tux.tux_poz(i,j);  break;
	  }
	  surx+=54;
	}
	surx=ZAC_X;
	sury+=54;
      }

      /*-------ZISTUJE-KOLKO-RYB-(4)-NIE-JE-NA-TANIERI---------------------*/

      vyskyt_ryba=0;
      for (i=0;i<8;i++)
	for (j=0;j<11;j++)
	  if (pole[i][j]==4) vyskyt_ryba+=1;
      if (vyskyt_ryba==0) { vyhra(); getch();  break; }
      /* ak su vsetky ryby na tanieri(5) - koniec */

      /*-------NACITAVANIE-STLACENEHO-KLAVESU------------------------------*/

      klaves = getch();
      if (!klaves)
	klaves = getch();
      switch (klaves) {
	case 72 : tux.tux_move((-1),0,pole); break;   /* sipka hore */

	case 80 : tux.tux_move (1,0,pole); break;     /* dole */

	case 75 : tux.tux_move (0,(-1),pole); break;  /* vlavo */

	case 77 : tux.tux_move (0,(1),pole); break;   /* vpravo */

	case 104 : help(); cleardevice(); break;      /* [h] */

	case 114 : cleardevice();                     /* [r] - restart */
		    stoji_tanier=0;
		   vst = fopen(cesta,"r");
		   for (i=0;i<8;i++)
		     for (j=0;j<11;j++) fscanf(vst,"%d",&pole[i][j]);
		   fclose (vst);
		   panel(cesta);
		   break;
      }


    } while (klaves!=27);
    stoji_tanier=0;

  } while (klaves != 999); /*nikdy nenastane*/



}

/*------------------------------END-OF-MAIN--------------------------------*/


void stena (int x, int y) {
  setcolor(12);
  setfillstyle(10, 12);
  rectangle (x-26,y-26,x+26,y+26);
  floodfill (x,y,12);
}

/*-------------------------------------------------------------------------*/

void nic (int x, int y) { setfillstyle(1,0 ); bar (x-27,y-27,x+27,y+27); }

/*-------------------------------------------------------------------------*/

void ryba (int x, int y) {
  /* telo */
  setcolor(1);
  line (x,y,x-10,y+25);
  line (x,y,x+10,y+25);
  line (x+10,y+25,x-10,y+25);
  setfillstyle(1, 1);
  floodfill (x,y+5,1);
  fillellipse(x, y-5,10 ,20 );
  /*oci*/
  setcolor(0);
  setfillstyle(1, 0);
  fillellipse(x-4, y-13,2 ,3 );
}

/*-------------------------------------------------------------------------*/

void tanier (int x, int y) {

  setcolor(15);
  setfillstyle(7,7 );
  bar (x-23,y-25,x+23,y+25);
  rectangle (x-24,y-26,x+24,y+26);
}

/*-------------------------------------------------------------------------*/

void vyhra () {
  setfillstyle(8,4 );
  bar (190,190,430,260);
  setfillstyle(1,7 );
  bar (200,200,420,250);
  setcolor(4); outtextxy(235,220,"Uroven dokoncena !");
}

/*-------------------------------------------------------------------------*/

void panel (char path[19]){
  setfillstyle(1,8 );
  bar (0,getmaxy()-30,getmaxx(),getmaxy());
  setcolor(15);
  outtextxy(150,getmaxy()-10,path);
  outtextxy(10,getmaxy()-10,"cesta k levelu :");

  outtextxy(10,getmaxy()-25,"[sipky] : pohyb   [r] : restart urovne   [h] : pomoc   [esc] : koniec" );
}

/*-------------------------------------------------------------------------*/

void menu (){
  cleardevice();
  setcolor(15);
  outtextxy(280,20,"Tux-O-Ban");
  outtextxy(200,200,"[F1] ... [F12]   - vyber levelov");
  outtextxy(200,220,"[h]              - pomoc");
  outtextxy(200,240,"[Esc]            - koniec");
  outtextxy(220,getmaxy()-10,"pavol odevak (pmk)");

}

/*-------------------------------------------------------------------------*/

void help (){
  Tux t;
  cleardevice();
  setcolor (7);
  outtextxy(getmaxx()/2-80,10,"welcome 2 TUX-O-BAN");
  outtextxy(200,380,"STLAC KLAVES PRE POKRACOVANIE");

  t.tux_show(140,100);

  outtextxy(140-11,60,"Tux");
  outtextxy(240-17,60,"stena");
  outtextxy(340-13,60,"ryba");
  outtextxy(440-20,60,"tanier");


  outtextxy(110,150,"Hras za Tux-a, ktoreho v hre ovladas za pomoci sipok.");
  outtextxy(110,160,"Tvojou ulohou je dostat vsetky ryby na hracej ploche");
  outtextxy(110,170,"na tanier. Kedze je to ale logicka hra, kazdy tah je");
  outtextxy(110,180,"potrebne dobre zvazit, lebo akonahle je ryba pri stene");
  outtextxy(110,190,"alebo v rohu uz sa neda vytiahnut, level sa potom musi");
  outtextxy(110,200,"restartnut za pomoci klavesu [r]. Pre ukoncenie hry");
  outtextxy(110,210,"staci slacit [Esc].");

  outtextxy(155,230,"PS: [r] nie je to iste ako [R].");
  outtextxy(155,240,"    Vsetky levely sa daju prejst.");

  outtextxy(110,310,"Design Levelov som si pozical z hry Ksokoban (4 Linux).");
  outtextxy(110,320,"Pre dalsie info si pozrite zdrojovy kod s poznamkami.");

  outtextxy(110,450,"2005 by pavol odlevak (pmk) napisane v borland c++ 3.1");
  stena (240,100);
  ryba(340,100);
  tanier(440,100);

  getch();

}
